<?php

/*
*
* INFOATCLUSTER TECHNOLABS LLP ("COMPANY") CONFIDENTIAL
* Copyright (c) 2016-2017 INFOATCLUSTER TECHNOLABS LLP, All Rights Reserved.
*
* NOTICE:  All information contained herein is, and remains the property of INFOATCLUSTER TECHNOLABS LLP. The intellectual and technical concepts contained
* herein are proprietary to INFOATCLUSTER TECHNOLABS LLP and may be covered by Indian and Foreign Patents, patents in process, and are protected by trade secret or copyright law.
* Dissemination of this information or reproduction of this material is strictly forbidden unless prior written permission is obtained
* from COMPANY.  Access to the source code contained herein is hereby forbidden to anyone except current COMPANY employees, managers or contractors who have executed 
* Confidentiality and Non-disclosure agreements explicitly covering such access.
*
* The copyright notice above does not evidence any actual or intended publication or disclosure  of  this source code, which includes  
* information that is confidential and/or proprietary, and is a trade secret, of  COMPANY.   ANY REPRODUCTION, MODIFICATION, DISTRIBUTION, PUBLIC  PERFORMANCE, 
* OR PUBLIC DISPLAY OF OR THROUGH USE  OF THIS  SOURCE CODE  WITHOUT  THE EXPRESS WRITTEN CONSENT OF COMPANY IS STRICTLY PROHIBITED, AND IN VIOLATION OF APPLICABLE 
* LAWS AND INTERNATIONAL TREATIES.  THE RECEIPT OR POSSESSION OF  THIS SOURCE CODE AND/OR RELATED INFORMATION DOES NOT CONVEY OR IMPLY ANY RIGHTS  
* TO REPRODUCE, DISCLOSE OR DISTRIBUTE ITS CONTENTS, OR TO MANUFACTURE, USE, OR SELL ANYTHING THAT IT  MAY DESCRIBE, IN WHOLE OR IN PART.                
*
*
* @author Mohammed Shayas M K
* 
*/

namespace App\Managers\LiveSchedulePlayers;
use App\Managers\LiveSchedulePlayers\LiveSchedulePlayersModel;
use Illuminate\Support\Facades\Hash;
use Illuminate\Support\Facades\Session;
use Illuminate\Support\Facades\DB;
use App\Http\Helper\Helper;

class LiveSchedulePlayersManager extends LiveSchedulePlayersModel
{
    public function __construct()
    {
         $this->helper = new Helper();
    }

    public function add($data)
    {
        $data['user_id'] = Session::get('admin');
        return $this->insertGetId($data);
    }
    
    public function updateData($data, $columns, $UUID)
    {
        DB::beginTransaction();
        try 
        {
            $scheduledPlayers = $this->where('schedule_id', $UUID)->get();
            if(count($scheduledPlayers) > 0)
            {
                $del = $this->where('schedule_id', $UUID)->delete();

                if(!$del)
                {
                    return 0;
                }
            }
            foreach($columns AS $key => $column)
            {
                if($key == 'undefined')
                {
                    return 0;
                }
                $data = array();
                $data['position_columns_id'] = $key;
                $data['schedule_id'] = $UUID;
                $data['player_id'] = $column;
                $data['user_id'] = Session::get('admin');
                
                $data['UUID'] = $this->helper->addUUID();
                
                $insert = $this->insert($data);
                if(!$insert)
                {
                    return 0;
                }
            }
            
            DB::commit();
            return 1;
        }
        catch(ValidationException $e)
        {
            DB::rollback();
            return 0;
        }
        
    }
    
    public function deletePlayerOfSchedule($playerID, $scheduleID)
    {
        return $this->where('player_id', $playerID)->where('schedule_id', $scheduleID)->delete();
    }
}