<?php

/*
*
* INFOATCLUSTER TECHNOLABS LLP ("COMPANY") CONFIDENTIAL
* Copyright (c) 2016-2017 INFOATCLUSTER TECHNOLABS LLP, All Rights Reserved.
*
* NOTICE:  All information contained herein is, and remains the property of INFOATCLUSTER TECHNOLABS LLP. The intellectual and technical concepts contained
* herein are proprietary to INFOATCLUSTER TECHNOLABS LLP and may be covered by Indian and Foreign Patents, patents in process, and are protected by trade secret or copyright law.
* Dissemination of this information or reproduction of this material is strictly forbidden unless prior written permission is obtained
* from COMPANY.  Access to the source code contained herein is hereby forbidden to anyone except current COMPANY employees, managers or contractors who have executed 
* Confidentiality and Non-disclosure agreements explicitly covering such access.
*
* The copyright notice above does not evidence any actual or intended publication or disclosure  of  this source code, which includes  
* information that is confidential and/or proprietary, and is a trade secret, of  COMPANY.   ANY REPRODUCTION, MODIFICATION, DISTRIBUTION, PUBLIC  PERFORMANCE, 
* OR PUBLIC DISPLAY OF OR THROUGH USE  OF THIS  SOURCE CODE  WITHOUT  THE EXPRESS WRITTEN CONSENT OF COMPANY IS STRICTLY PROHIBITED, AND IN VIOLATION OF APPLICABLE 
* LAWS AND INTERNATIONAL TREATIES.  THE RECEIPT OR POSSESSION OF  THIS SOURCE CODE AND/OR RELATED INFORMATION DOES NOT CONVEY OR IMPLY ANY RIGHTS  
* TO REPRODUCE, DISCLOSE OR DISTRIBUTE ITS CONTENTS, OR TO MANUFACTURE, USE, OR SELL ANYTHING THAT IT  MAY DESCRIBE, IN WHOLE OR IN PART.                
*
*
* @author Mohammed Shayas M K
* 
*/

namespace App\Managers\PlayerRatingSubstitute;
use App\Managers\PlayerRatingSubstitute\PlayerRatingSubstituteModel;
use Illuminate\Support\Facades\Hash;
use Illuminate\Support\Facades\Session;
use App\Managers\User\UserManager;
use Illuminate\Support\Facades\DB;
use App\Http\Helper\Helper;

class PlayerRatingSubstituteManager extends PlayerRatingSubstituteModel
{
    public function __construct()
    {
         $this->helper = new Helper();
    }
    
    public function getSubRatings($scheduleID)
    {
        return $this->select(DB::raw("SUM(sub_1)/COUNT(*) as rating_count1"),DB::raw("SUM(sub_2)/COUNT(*) as rating_count2"),DB::raw("SUM(sub_3)/COUNT(*) as rating_count3"),DB::raw("SUM(sub_4)/COUNT(*) as rating_count4"),DB::raw("SUM(sub_5)/COUNT(*) as rating_count5"))
                ->where('scheduled_id', $scheduleID)->first();
                
    }
    
    public function getPlayerRatinsForEachScheuleRawSub1($playerID)
    {
        return $this->select('schedule.UUID','schedule.name','schedule.date_date', 'player_ratings_substitute.sub_1')
                ->join('schedule', 'schedule.UUID', '=', 'player_ratings_substitute.scheduled_id')
                ->where('schedule.new_player_1', $playerID)
                ->orderBy('schedule.created_at', 'DESC')
                ->get();
    }
    
    public function getPlayerRatinsForEachScheuleRawSub2($playerID)
    {
        return $this->select('schedule.UUID','schedule.name','schedule.date_date', 'player_ratings_substitute.sub_2')
                ->join('schedule', 'schedule.UUID', '=', 'player_ratings_substitute.scheduled_id')
                ->where('schedule.new_player_2', $playerID)
                ->orderBy('schedule.created_at', 'DESC')
                ->get();
    }
    
    public function getPlayerRatinsForEachScheuleRawSub3($playerID)
    {
        return $this->select('schedule.UUID','schedule.name','schedule.date_date', 'player_ratings_substitute.sub_3')
                ->join('schedule', 'schedule.UUID', '=', 'player_ratings_substitute.scheduled_id')
                ->where('schedule.new_player_3', $playerID)
                ->orderBy('schedule.created_at', 'DESC')
                ->get();
    }
    
    
    public function getPlayerRatinsForCurrentScheuleRawSub1($scheduleID, $playerID)
    {
        return $this->select('schedule.UUID','schedule.name','schedule.date_date', 'player_ratings_substitute.sub_1')
                ->join('schedule', 'schedule.UUID', '=', 'player_ratings_substitute.scheduled_id')
                ->where('schedule.new_player_1', $playerID)
                ->where('schedule.UUID', $scheduleID)
                ->orderBy('schedule.created_at', 'DESC')
                ->get();
    }
    
    public function getPlayerRatinsForCurrentScheuleRawSub2($scheduleID, $playerID)
    {
        return $this->select('schedule.UUID','schedule.name','schedule.date_date', 'player_ratings_substitute.sub_2')
                ->join('schedule', 'schedule.UUID', '=', 'player_ratings_substitute.scheduled_id')
                ->where('schedule.new_player_2', $playerID)
                ->where('schedule.UUID', $scheduleID)
                ->orderBy('schedule.created_at', 'DESC')
                
                ->get();
    }
    
    public function getPlayerRatinsForCurrentScheuleRawSub3($scheduleID, $playerID)
    {
        return $this->select('schedule.UUID','schedule.name','schedule.date_date', 'player_ratings_substitute.sub_3')
                ->join('schedule', 'schedule.UUID', '=', 'player_ratings_substitute.scheduled_id')
                ->where('schedule.new_player_3', $playerID)
                ->where('schedule.UUID', $scheduleID)
                ->orderBy('schedule.created_at', 'DESC')
                ->get();
    }
}