<?php

/*
*
* INFOATCLUSTER TECHNOLABS LLP ("COMPANY") CONFIDENTIAL
* Copyright (c) 2016-2017 INFOATCLUSTER TECHNOLABS LLP, All Rights Reserved.
*
* NOTICE:  All information contained herein is, and remains the property of INFOATCLUSTER TECHNOLABS LLP. The intellectual and technical concepts contained
* herein are proprietary to INFOATCLUSTER TECHNOLABS LLP and may be covered by Indian and Foreign Patents, patents in process, and are protected by trade secret or copyright law.
* Dissemination of this information or reproduction of this material is strictly forbidden unless prior written permission is obtained
* from COMPANY.  Access to the source code contained herein is hereby forbidden to anyone except current COMPANY employees, managers or contractors who have executed 
* Confidentiality and Non-disclosure agreements explicitly covering such access.
*
* The copyright notice above does not evidence any actual or intended publication or disclosure  of  this source code, which includes  
* information that is confidential and/or proprietary, and is a trade secret, of  COMPANY.   ANY REPRODUCTION, MODIFICATION, DISTRIBUTION, PUBLIC  PERFORMANCE, 
* OR PUBLIC DISPLAY OF OR THROUGH USE  OF THIS  SOURCE CODE  WITHOUT  THE EXPRESS WRITTEN CONSENT OF COMPANY IS STRICTLY PROHIBITED, AND IN VIOLATION OF APPLICABLE 
* LAWS AND INTERNATIONAL TREATIES.  THE RECEIPT OR POSSESSION OF  THIS SOURCE CODE AND/OR RELATED INFORMATION DOES NOT CONVEY OR IMPLY ANY RIGHTS  
* TO REPRODUCE, DISCLOSE OR DISTRIBUTE ITS CONTENTS, OR TO MANUFACTURE, USE, OR SELL ANYTHING THAT IT  MAY DESCRIBE, IN WHOLE OR IN PART.                
*
*
* @author Mohammed Shayas M K
* 
*/

namespace App\Managers\Position;
use App\Managers\Position\PositionModel;
use Illuminate\Support\Facades\Hash;
use Illuminate\Support\Facades\Session;
use Illuminate\Support\Facades\DB;
use App\Managers\PositionColumns\PositionColumnsManager;
use App\Http\Helper\Helper;

class PositionManager extends PositionModel
{
    public function __construct()
    {
        $this->positionColumns = new PositionColumnsManager();
        $this->helper = new Helper();
    }

    public function add($data, $columns)
    {
        DB::beginTransaction();
        try 
        {
            
            $data['user_id'] = Session::get('admin');
            $positionID = $this->insertGetId($data);
            
            if(!$positionID)
            {
                return 0;
                exit;
            }
            
            $position = $this->where('id', $positionID)->first();
            
            if(!empty($columns))
            {
                foreach($columns AS $key => $value)
                {
                    $res = $this->positionColumns->where('column_count', $value)->where('inactive',0)->where('deleted_at', NULL)->first();
                    
                    if($res)
                    {
                        return 0;
                    }
                    
                    $columnAdd = array();
                    $columnAdd['position_id'] = $position->UUID;
                    $columnAdd['column_count'] = $value;
                    $columnAdd['user_id'] = Session::get('admin');
                    $columnAdd['UUID'] = $this->helper->addUuid();
                    $col = $this->positionColumns->insertData($columnAdd);
                    if(!$col)
                    {
                        return 0;
                    }
                }
            }
            else
            {
                return 0;
                exit;
            }
            
            DB::commit();
            return 1;
        }
        catch(ValidationException $e)
        {
            DB::rollback();
            return 0;
        }
    }
    
    public function updateData($data, $columns, $UUID)
    {
        DB::beginTransaction();
        try 
        {
            $update = $this->where('UUID', $UUID)->update($data);
            
            if(!$update)
            {
                return 0;
            }
            
            if(!empty($columns))
            {
                $positions = $this->positionColumns->where('position_id', $UUID)->get();
                
                if(count($positions) > 0)
                {
                    $del = $this->positionColumns->where('position_id', $UUID)->update(array('inactive' => 1));
                    if(!$del)
                    {
                        return 0;
                        exit;
                    }
                }
                foreach($columns AS $key => $value)
                {
                    $res = $this->positionColumns->where('column_count', $value)->where('inactive',1)->first();
                    if($res)
                    {
                        $columnAdd = array();
                        $columnAdd['inactive'] = 0;
                        $col = $this->positionColumns->updateData($columnAdd, $res->UUID);
                        if(!$col)
                        {
                            return 0;
                            exit;
                        }
                    }
                    else
                    {
                        $columnAdd = array();
                        $columnAdd['position_id'] = $UUID;
                        $columnAdd['column_count'] = $value;
                        $columnAdd['user_id'] = Session::get('admin');
                        $columnAdd['UUID'] = $this->helper->addUuid();
                        $col = $this->positionColumns->insertData($columnAdd);
                        if(!$col)
                        {
                            return 0;
                            exit;
                        }
                    }
                }
            }
            else
            {
                return 0;
                exit;
            }
            
            DB::commit();
            return 1;
        }
        catch(ValidationException $e)
        {
            DB::rollback();
            return 0;
        }
    }
    
    public function deleteData($UUID)
    {
        DB::beginTransaction();
        try 
        {
            $del1 = $this->positionColumns->where('position_id', $UUID)->delete();
            if(!$del1)
            {
                return 0;
            }
            $del2 = $this->where('UUID', $UUID)->delete();
            if(!$del2)
            {
                return 0;
            }
            DB::commit();
            return 1;
        } catch (Exception $ex) {
            DB::rollback();
            return 0;
        }
    }
}