<?php

use Illuminate\Support\Facades\Schema;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Database\Migrations\Migration;

class AddColumnToTables extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::table('proposal', function (Blueprint $table) {
            $table->text('contact_player_information')->nullable()->after('no_of_likes');
            $table->date('expiry_date')->nullable()->after('contact_player_information');
        });
        
        Schema::table('decision', function (Blueprint $table) {
            $table->date('expiry_date')->nullable()->after('ip');
        });
        
        Schema::table('decision_polls', function (Blueprint $table) {
            $table->datetime('expiry_date')->nullable()->after('name');
            $table->boolean('default_poll')->default(0)->after('expiry_date');
        });
        
        Schema::table('player', function (Blueprint $table) {
            $table->text('contact_player_information')->nullable()->after('dob');
        });
        
        Schema::table('player_ratings_substitute', function (Blueprint $table) {
            $table->bigInteger('no_of_votes')->default(1)->after('sub_3');
        });
        
        Schema::table('tactic_suggestions', function (Blueprint $table) {
            $table->date('expiry_date')->nullable()->after('no_of_likes');
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        //
    }
}
