<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/
require_once 'admin/routes.php';
require_once 'coach/routes.php';
require_once 'context.php';
require_once 'solutia.php';
require_once 'perspectiva.php';
require_once 'strategia.php';
require_once 'strategia2.php';
require_once 'date.php';
require_once 'newsocios.php';
require_once 'email-cron.php';
require_once 'sociospsg.php';
require_once 'sociosjuventus.php';
require_once 'sociosdinamo.php';


/* Auth */
Route::group(['middleware' => ['web'], 'prefix' => 'api/v1/auth'], function(){
    Route::post('/register', 'AuthController@register');
    Route::post('/login', 'AuthController@login');
    Route::get('/general/logout', 'AuthController@logout');
    
    Route::post('/password/reset', 'AuthController@resetPasswordLinkSent');
    
    Route::post('/reset/password', 'AuthController@mainResetPassword');
});

/* API Calls */


Route::group(['middleware' => ['web', 'cookie', 'admin-general-api-access'], 'prefix' => 'api/v1'], function(){
    Route::get('/positions/columns/all', 'Admin\AdminPositionController@allPositionColumns');
    Route::get('/schedule/{id}/players/get', 'Admin\AdminScheduleController@getPlayersForSchedule');
    Route::get('/formations/{id}/players/get', 'Admin\AdminFormationsController@getColumnsOfFormations');
    Route::get('/schedule/{id}/players/ratings', 'Admin\AdminScheduleController@getRatingsOfPlayersForSchedule');
    Route::get('tactic/suggestions/all', 'MainApiController@allTacticSuggestions');
    Route::get('/schedule/{id}/pre/formation', 'Admin\AdminScheduleController@getpreMatchFormationInfo');
    Route::get('/schedule/{id}/position/order', 'Admin\AdminScheduleController@getAllPlayerPositionRatingOrder');
    Route::get('/player/{id}/ratings', 'Admin\AdminPlayerController@getPlayerRating');
    Route::get('/schedule/{scheduleID}/player/{id}/ratings', 'Admin\AdminPlayerController@getPlayerRatingOfSchedule');
    Route::get('player/{playerID}/ratings/current', 'MainController@getCurrentPlayerRating');


});

Route::group(['middleware' => ['web','cookie', 'general-api-access'], 'prefix' => 'api/v1'], function(){
    
    Route::get('schedule/previous/formation', 'MainApiController@getLatestPlayedMatchFormation');
 
    Route::get('/schedule/{id}/formation', 'Admin\AdminScheduleController@getpreMatchFormationInfo');
    Route::get('/schedule/{id}/post/formation', 'Admin\AdminScheduleController@getpostMatchFormationInfo');
//    Route::get('/schedule/{ID}/tactics', 'Admin\AdminReportsController@getTacticsReport');
//    Route::get('/schedule/{ID}/player/evaluation', 'Admin\AdminReportsController@getPlayerEvaluationReport');
    
    //Route::get('/banners', 'AuthController@register');
    Route::post('banner/submit', 'MainApiController@submitBanner');
    Route::get('member', 'MainApiController@member');
    
    Route::post('account/update', 'MainApiController@updateAccount');
    Route::post('decision/proposal/add', 'MainApiController@addDecisionProposal');
    Route::post('proposal/add', 'MainApiController@addProposal');
    Route::get('proposals/all', 'MainApiController@allProposals');
    Route::get('decision/proposals/all', 'MainApiController@allDecisionProposals');
    Route::get('decision/proposals/active', 'MainApiController@allActiveDecisionProposals');
    
    Route::post('proposal/like', 'MainApiController@likeProposal');
    Route::post('decision/proposal/like', 'MainApiController@likeDecisionProposal');
    
    Route::get('/schedule/list', 'MatchesApiController@listAll');
    
    
    Route::get('/schedule/{id}/players/ratings/votes', 'MainApiController@getRemainignVotesOnPlayerRatings');
    Route::get('/schedule/{id}/substitution/votes', 'MainApiController@getRemainingVotesOnSubstitution');
    Route::get('/player/{id}/rating', 'Admin\AdminScheduleController@getPlayerRating');
    Route::post('/schedule/{id}/players/save', 'MainApiController@savePlayerRatings');
    
    Route::post('/tactics/players/save', 'MainApiController@saveTactics');
    Route::post('/tactics/results', 'MainApiController@getLatestTactics');
    Route::post('/substitution/results', 'MainApiController@getSubstitutionProposalResults');
    Route::post('/tactics/each/results', 'MainApiController@getEachTactics');
    Route::get('/schedule/{id}', 'Admin\AdminScheduleController@currentSchedule');
    
    
   
    
    Route::post('tactic/suggestion/add', 'MainApiController@addTacticSuggestions');
    Route::post('tactic/suggestions/like', 'MainApiController@likeTacticSuggestions');
    Route::get('tactic/suggestions/active', 'MainApiController@activeTacticSuggestions');
    Route::get('tactics/latest/formation', 'MainApiController@getLatestMatchPreFormation');
    Route::get('tactics/latest/formation/results', 'MainApiController@getLatestMatchPreFormationResults');
    Route::get('tactics/latest/formation/results1', 'MainApiController@getLatestMatchPreFormationResults1');
    Route::get('tactics/coming/formation', 'MainApiController@getComingMatchFormation');
    
     Route::get('/schedule/{id}/pre/formation/general', 'MainApiController@getCurrentMatchPreFormationInfo');
     Route::get('/schedule/{id}/post/formation/general', 'MainApiController@getCurrentMatchPostFormationInfo');
    
    Route::post('live/proposal/add', 'LiveProposalApiController@addLiveProposal');
    Route::post('live/proposal/like', 'LiveProposalApiController@likeLiveProposal');
    Route::get('live/proposal/active', 'LiveProposalApiController@activeLiveProposals');
    
    Route::get('votes/count', 'MainApiController@currentUserVotesCount');
    
    Route::get('tactics/player/evaluation/{scheduleID}/votes', 'MainApiController@getPlayerEvaluationRemainingVotes');

    Route::post('/vote/post/one', 'PaymentApiController@postOneVote');
    
    Route::get('/banners/all/pending', 'MainApiController@allPendingBanners');
    Route::post('/banners/{UUID}/delete', 'MainApiController@deleteBanner');
    
    Route::get('/player/{playerID}/positions', 'MainApiController@playerPositions');
    
    Route::get('/mobilpay/check/{orderID}', 'MainApiController@checkMobilPayOrder');

    Route::post('/schedule/{scheduleID}/substitution/proposal/save', 'MainApiController@saveSubstitutionProposal');



    //Route::post('/substitution/proposal/save', 'MainApiController@saveSubstitutionProposal');
});

Route::group(['middleware' => ['web'], 'prefix' => 'auth'], function(){
    Route::get('/confirm/{conf_id}/{UUID}', 'AuthController@confirmAccount');
    Route::get('/confirm/{conf_id}/{UUID}/send/email', 'AuthController@confirmAccountSendEmail');
    Route::get('/login', 'AuthController@loginForm');
    Route::get('/password/reset/{UUID}/{RESET_CODE}', 'AuthController@resetPassword');
    Route::post('/password/reset/{UUID}/{RESET_CODE}', 'AuthController@resetPasswordAjax');
    Route::get('/check-{id}-{id1}', 'AuthController@test');
});


/* Home */
Route::group(['middleware' => ['web', 'cookieNoLogin']], function(){
    Route::get('/', function () {
        return view('main/index');
    });
});

Route::get('/p', 'AuthController@p');

Route::group(['middleware' => ['web', 'cookieNoLogin']], function(){
    Route::get('/terms', 'StaticController@terms');
    Route::get('/contact', 'StaticController@contact');
    Route::post('/contact/send', 'StaticController@sendContact');

    Route::get('/banner', 'MainController@banner');


    Route::get('/api/v1/banners/all', 'MainApiController@allBanners');

    Route::get('/user/{uuid}', 'UserController@index');
    Route::get('/payment', 'MainController@payment');
    Route::get('/member', 'MainController@member');
    Route::get('/member/{status}', 'MainController@memberStatus');
    Route::post('/mobilpay/confirm', 'MainController@confirmMobilPay');
});
Route::group(['middleware' => ['web'], 'prefix' => 'api/v1'], function(){
    Route::post('/member/paypal/notify/{user_id}', 'MainApiController@memberPaypal');
    Route::post('/decision/proposal/poll/vote/{pollOptionID}', 'PollsApiController@votePoll');
    Route::get('/profile/info', 'ProfileApiController@profileInfo');
    Route::get('decision/polls/all', 'PollsApiController@allDecisionPolls');
});

Route::group(['middleware' => ['web','cookie', 'general-access', 'payment']], function(){
    Route::get('/poll/combinated', 'CombinatedPollController@index');
    
    Route::get('/matches', 'MatchesController@index');
    Route::get('/matches/{ID}/tactics', 'MatchesController@tactics');
    Route::get('/matches/{ID}/player/evaluation', 'MatchesController@playerEvaluation');
    Route::get('/matches/{ID}/players', 'MatchesController@getAllPostMatchFormationPlayers');
    Route::get('/matches/{ID}/substitution', 'MatchesController@substitutionProposal');
    
    Route::get('/proposal', 'MainController@proposal');
    Route::get('/decision/proposal', 'MainController@decisionProposal');
    
    
    Route::get('/buy', 'MainController@buy');
    Route::get('/tactics/player/evaluation', 'MainController@playerEvaluation');
    Route::get('/tactics/player/evaluation/results', 'MainController@playerEvaluationResults');
    Route::get('/tactics', 'MainController@tactics');
    Route::get('/tactics/results', 'MainController@tacticsResults');
    Route::get('/tactics/results', 'MainController@tacticsResults');

    Route::get('/players', 'MainController@players');
    Route::get('/player/{id}', 'MainController@currentPlayer');
    
    Route::get('/vote_for_substitution', 'MainController@voteForSubstitution');
    Route::get('/vote_for_substitution/results', 'MainController@substitutionResults');
    
    //Route::post('/votes/pay', 'MainController@payForVotes');
    
    Route::get('votes/individual', 'MainController@allVotes');
    
    
    Route::get('/live', 'MainController@live');
    Route::get('/live/archieve', 'MainController@liveArchieve');
    
    
    //Route::get('/mobilpay/confirm', 'MainController@confirmMobilPay');
    //Route::post('/mobilpay/confirm', 'MainController@confirmMobilPay');
    
    Route::get('/mobilpay/failure', 'MainController@failureMobilPay');
    
    Route::get('/mailbox', 'MailboxController@mailbox');
    Route::get('/mailbox/{id}', 'MailboxController@mailboxView');
});

Route::get('/mobilpay/return', 'MainController@returnMobilPay');

Route::group(['middleware' => ['web', 'cookie','general-access']], function(){
    
    Route::get('/votes/pay/{count}/{noOfVotes}', 'MainController@payForVotes');
    
});


Route::group(['middleware' => ['web', 'cookie','general-access-votes', 'payment-without-redirection']], function(){
    
    Route::get('/votes', 'MainController@votes');
    Route::get('/account', 'MainController@account');
    Route::get('/banner/pay', 'MainController@payForBanner');
    Route::get('/banner/confirm', 'MainController@confirmBannerPayment');
    
    
});

//Route::get('/banner', function () {
//    return view('main/banner');
//    
//});
Route::group(['middleware' => ['web', 'cookieNoLogin']], function(){
    Route::post('/banner/confirm', 'MainController@confirmBannerPayment');
    Route::get('/banner/return', 'MainController@returnBannerPayment');
    Route::get('/banner/failure', 'MainController@failureBannerPayment');
});



Route::get('/qstart', function () {
    Artisan::call('queue:work');
});

Route::group(['middleware' => ['web', 'cookie', 'general-access-votes'], 'prefix' => 'archive'], function(){
    Route::get('/decision/polls', 'ArchiveController@decisionPoll');
    Route::get('/decision/proposal', 'ArchiveController@decisionProposal');
    Route::get('/tactic/proposal', 'ArchiveController@tacticProposal');
    Route::get('/player/proposal', 'ArchiveController@playerProposal');
    Route::get('/live/proposal', 'ArchiveController@liveProposal');

});